<?xml version="1.0" encoding="UTF-8"?>

<configuration scan="true">

    <!--Properties for log dir & file are managed in application*.yml-->
    <springProperty name="logDir" source="base.log.dir"/>
    <springProperty name="logFilePrefix" source="base.log.filePrefix"/>
    <springProperty name="apiLogLevel" source="base.log.apiLogLevel"/>

    <!-- use Spring default values -->
    <include resource="org/springframework/boot/logging/logback/defaults.xml"/>

    <!-- Custom context listener -->
    <contextListener class="com.stefanomantini.tools.restgateway.service.config.LoggerStartupListener"/>

    <!--Custom TID property-->
    <conversionRule conversionWord="tid"
                    converterClass="com.stefanomantini.tools.restgateway.service.config.ThreadIdConverter"/>

    <logger name="com.stefanomantini.tools.restgateway.service.impl.LogServiceImpl" level="${apiLogLevel}"/>

    <appender name="CONSOLE" class="ch.qos.logback.core.ConsoleAppender">
        <encoder>
            <charset>UTF-8</charset>
            <pattern>%d{E MMM dd HH:mm:ss YYYY}: [%p] Thrd:%tid: %c:%line %msg %n</pattern>
        </encoder>
    </appender>

    <root level="INFO">
        <appender-ref ref="CONSOLE"/>
    </root>

    <!--log profile only adds in this config-->
    <springProfile name="log">
        <appender name="FILE" class="ch.qos.logback.core.rolling.RollingFileAppender">
            <file>${logDir}/${INSTANCE_NAME}/${logFilePrefix}-${INSTANCE_NAME}.log</file>
            <rollingPolicy class="ch.qos.logback.core.rolling.SizeAndTimeBasedRollingPolicy">
                <fileNamePattern>
                    ${logDir}/${INSTANCE_NAME}/${logFilePrefix}-${INSTANCE_NAME}_%d{yyyy-MM-dd}.%i.log
                </fileNamePattern>
                <maxFileSize>10GB</maxFileSize>
            </rollingPolicy>
            <encoder>
                <pattern>%d{E MMM dd HH:mm:ss YYYY}: [%p] Thrd:%tid: %c:%line %msg %n</pattern>
            </encoder>
        </appender>
        <root level="INFO">
            <appender-ref ref="CONSOLE"/>
            <appender-ref ref="FILE"/>
        </root>

    </springProfile>


</configuration>
